"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AnimationManager = void 0;
const svg_1 = require("../utils/svg");
class AnimationManager {
    constructor(chart) {
        this.chart = chart;
    }
    update(options) {
        this.options = options;
    }
    fillUpOriginShapes(ele) {
        var _a, _b;
        let length = 2;
        if (((_a = ele.shapes[0]) === null || _a === void 0 ? void 0 : _a.type) === 'path') {
            length = (((_b = ele.shapes[0]) === null || _b === void 0 ? void 0 : _b.d.match(/M|L/g)) || []).length;
        }
        return ele.shapes.map(shape => (Object.assign(Object.assign({}, shape), { d: (0, svg_1.generateSVGPath)(Array(length).fill(this.chart.layoutManager.origin), length > 2) })));
    }
    findLastElement(cid, eid, prev) {
        return prev
            .filter(el => el.cid === cid && el.eid.split('-').length === eid.split('-').length) // TODO: find better way to check element id
            .sort(el => (el.eid.split('-')[1] > eid.split('-')[1] ? 1 : -1))[0];
    }
    composeAnimation(cur, prev) {
        var _a, _b;
        if (prev.length === 0 && ((_a = this.options) === null || _a === void 0 ? void 0 : _a.enter)) {
            // entering animation
            return cur.map(element => {
                var _a;
                return (Object.assign(Object.assign({}, element), { prevShapes: this.fillUpOriginShapes(element), animating: true, animateOptions: (_a = this.options) === null || _a === void 0 ? void 0 : _a.enter }));
            });
        }
        else if (prev.length !== 0 && ((_b = this.options) === null || _b === void 0 ? void 0 : _b.update)) {
            // update animation
            return cur.map(element => {
                var _a, _b, _c;
                const prevElement = prev.find(pre => pre.eid === element.eid);
                let prevShapes = prevElement === null || prevElement === void 0 ? void 0 : prevElement.shapes;
                if (!prevShapes && ((_b = (_a = this.options) === null || _a === void 0 ? void 0 : _a.update) === null || _b === void 0 ? void 0 : _b.type) === 'gradual') {
                    prevShapes = this.findLastElement(element.cid, element.eid, prev).shapes;
                }
                return Object.assign(Object.assign({}, element), { prevShapes, animating: !!prevShapes, animateOptions: (_c = this.options) === null || _c === void 0 ? void 0 : _c.update });
            });
        }
        return cur;
    }
}
exports.AnimationManager = AnimationManager;
