"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DataSource = void 0;
const scale_1 = __importDefault(require("../scale"));
const data_1 = require("../utils/data");
const judgement_1 = require("../utils/judgement");
class DataSource {
    constructor(data, scaleOptions) {
        this.data = data;
        this.fields = data
            .map(record => Object.keys(record))
            .reduce((res, val) => res.concat(val), []) // flatten
            .filter(data_1.uniqueFilter)
            .reduce((res, field) => {
            const fieldDatas = data.map(record => record[field]).filter(value => !(0, judgement_1.isNil)(value));
            const fieldScale = new scale_1.default(fieldDatas, scaleOptions === null || scaleOptions === void 0 ? void 0 : scaleOptions[field]);
            return Object.assign(Object.assign({}, res), { [field]: {
                    data: fieldDatas,
                    scale: fieldScale,
                } });
        }, {});
    }
    getData() {
        return this.data;
    }
    getField(field) {
        var _a;
        const { data, scale } = (_a = this.fields[field]) !== null && _a !== void 0 ? _a : {};
        return {
            getData() {
                return data;
            },
            getScale() {
                return scale;
            },
        };
    }
}
exports.DataSource = DataSource;
