/// <reference types="lodash" />
import { Element } from '../types/geometry';
import { InteractionManagerOptions, TouchEvent, InteractionState, InteractionEvent } from '../types/interaction';
export declare class InteractionManager {
    private touch;
    private interactiveElements;
    private state;
    private subscriber;
    private listener;
    update(options: InteractionManagerOptions): void;
    private updateState;
    createEventSource<E>(transformer: (event: E) => TouchEvent): (event: E) => void | undefined;
    dispatch: import("lodash").DebouncedFunc<(event: TouchEvent) => void>;
    listen(cb: (interaction: InteractionEvent) => void): () => void;
    subscript(eid: string, cb: (state: InteractionState) => void): () => void;
    private notify;
    get activeElements(): Element[];
}
