"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const scale_1 = require("@antv/scale");
class Coordinate {
    constructor(options) {
        this.update(options);
    }
    update(options) {
        var _a;
        this.options = Object.assign(Object.assign(Object.assign({}, Coordinate.defaultOptions), ((_a = this.options) !== null && _a !== void 0 ? _a : {})), options);
        const { width, height, origin } = this.options;
        this.rangeScale = new scale_1.Linear({ domain: [origin.x, origin.x + width], range: [origin.y + height, origin.y] });
        this.center = { x: origin.x + width / 2, y: origin.y + height / 2 };
    }
    get isPolar() {
        return this.options.type === 'polar';
    }
    get isTransposed() {
        var _a;
        return (_a = this.options.transposed) !== null && _a !== void 0 ? _a : false;
    }
    // abstract matrix: Array<number[]>
    transpose(point) {
        return this.options.transposed === true
            ? { x: this.rangeScale.invert(point.y), y: this.rangeScale.map(point.x) }
            : point;
    }
}
exports.default = Coordinate;
Coordinate.defaultOptions = {
    type: 'rect',
    transposed: false,
    origin: { x: 0, y: 0 },
    width: 0,
    height: 0,
    innerRadius: 0,
    radius: 1,
    startAngle: -Math.PI / 2,
    endAngle: (3 * Math.PI) / 2,
};
