import { AestheticFunction, AestheticOptions, GraphicOptions, DataRecord, Dimension, DirectValue, Point, AestheticAttrs, AestheticConfigObject } from '../types';
import type { DataSource } from '../chart/data';
export declare class Aesthetic {
    position: AestheticFunction<Point>;
    size: AestheticFunction<number> | (() => number);
    shape: AestheticFunction<string>;
    color: AestheticFunction<string>;
    label: AestheticFunction<string>;
    constructor(defaultOptions: Record<AestheticAttrs, AestheticConfigObject<any>>, options: AestheticOptions, graphicOptions: GraphicOptions, ds: DataSource);
    protected formatAestheticOption(options: Dimension | DirectValue<unknown> | AestheticConfigObject<unknown>): AestheticConfigObject<any>;
    createPositionFunc(options: AestheticConfigObject<null>, graphicOptions: GraphicOptions, ds: DataSource): (record: DataRecord) => {
        x: any;
        y: any;
    };
    createSizeFunc(options: AestheticConfigObject<number>, ds: DataSource): (record: DataRecord) => any;
    createShapeFunc(): () => string;
    createColorFunc(options: AestheticConfigObject<string>, ds: DataSource): (record: DataRecord) => any;
    createLabelFunc(): () => string;
}
