import { DataRecord, GraphicOptions } from '../types/chart';
import { Element, IntervalOptions, Point } from '../types/geometry';
import { Chart } from '../chart';
import { Geometry } from './abstract';
import { Aesthetic } from './aesthetic';
import { Coordinate } from '../coord';
export declare class Interval extends Geometry {
    type: string;
    options: IntervalOptions;
    animatable: boolean;
    defaultAestheticOptions: {
        position: {};
        shape: {};
        size: {
            value: number[];
        };
        color: {
            value: string[];
        };
        label: {};
    };
    groupedData: DataRecord[][];
    constructor(chart: Chart, options: IntervalOptions);
    update(options: IntervalOptions): void;
    getCoordinateWidth(chart: Chart, graphicOptions: GraphicOptions, aesthetic: Aesthetic): number;
    graphic(chart: Chart, graphicOptions: GraphicOptions): Element[];
    coordinate(points: Point[] | Point, coord: Coordinate, seal?: boolean): string | Point;
}
