import { GraphicOptions } from '../types/chart';
import { Element, LineOptions, Point } from '../types/geometry';
import { Chart } from '../chart';
import { Geometry } from './abstract';
import { Coordinate } from '../coord';
export declare class Line extends Geometry {
    type: string;
    animatable: boolean;
    options: LineOptions;
    defaultAestheticOptions: {
        position: {};
        shape: {};
        size: {
            value: number[];
        };
        color: {
            value: string[];
        };
        label: {};
    };
    constructor(chart: Chart, options: LineOptions);
    update(options: LineOptions): void;
    graphic(chart: Chart, graphicOptions: GraphicOptions): Element[];
    coordinate(points: Point[] | Point, coord: Coordinate, seal?: boolean): string | Point;
}
