"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GuideLine = void 0;
const merge_1 = __importDefault(require("lodash-es/merge"));
const color_1 = require("../const/color");
const component_1 = require("../chart/component");
const abstract_1 = require("./abstract");
const aesthetic_1 = require("./aesthetic");
class GuideLine extends abstract_1.Guide {
    constructor(chart, options) {
        super(chart, component_1.ComponentType.GuideLine);
        this.animatable = false;
        this.defaultOptions = {
            style: {
                strokeWidth: 1,
                strokeColor: color_1.LINE_COLOR,
            },
        };
        this.update(options);
    }
    update(options) {
        this.options = (0, merge_1.default)(this.defaultOptions, options);
    }
    graphic(chart, graphicOptions) {
        const aesthetic = new aesthetic_1.Aesthetic(chart, graphicOptions);
        const from = aesthetic.position(this.options.start);
        const to = aesthetic.position(this.options.end);
        return [
            {
                cid: this.id,
                eid: this.id,
                shapes: [
                    Object.assign({ type: 'line', from,
                        to }, this.options.style),
                ],
            },
        ];
    }
}
exports.GuideLine = GuideLine;
