"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GuidePoint = void 0;
const merge_1 = __importDefault(require("lodash-es/merge"));
const color_1 = require("../const/color");
const component_1 = require("../chart/component");
const abstract_1 = require("./abstract");
const aesthetic_1 = require("./aesthetic");
class GuidePoint extends abstract_1.Guide {
    constructor(chart, options) {
        super(chart, component_1.ComponentType.GuidePoint);
        this.animatable = false;
        this.defaultOptions = {
            size: 2,
            style: {
                fill: color_1.DEFAULT_COLORS[0],
            },
        };
        this.update(options);
    }
    update(options) {
        this.options = (0, merge_1.default)(this.defaultOptions, options);
    }
    graphic(chart, graphicOptions) {
        const aesthetic = new aesthetic_1.Aesthetic(chart, graphicOptions);
        const center = aesthetic.position(this.options.position);
        return [
            {
                cid: this.id,
                eid: this.id,
                shapes: [
                    Object.assign({ type: 'circle', center, radius: this.options.size }, this.options.style),
                ],
            },
        ];
    }
}
exports.GuidePoint = GuidePoint;
