"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.nearest = exports.mapObject = exports.unifyArray = exports.getSampleValueOfField = exports.getValuesOfField = exports.uniqueFilter = void 0;
const uniqueFilter = (value, index, self) => self.indexOf(value) === index;
exports.uniqueFilter = uniqueFilter;
const getValuesOfField = (data, field) => data.filter(record => Object.prototype.hasOwnProperty.call(record, field)).map(record => record[field]);
exports.getValuesOfField = getValuesOfField;
const getSampleValueOfField = (data, field) => { var _a; return (_a = data.find(record => Object.prototype.hasOwnProperty.call(record, field))) === null || _a === void 0 ? void 0 : _a[field]; };
exports.getSampleValueOfField = getSampleValueOfField;
const unifyArray = (value) => (Array.isArray(value) ? value : [value]);
exports.unifyArray = unifyArray;
const mapObject = (obj, mapFn) => Object.entries(obj)
    .map(([key, value]) => [key, mapFn(value)])
    .reduce((res, [key, value]) => (Object.assign(Object.assign({}, res), { [key]: value })), {});
exports.mapObject = mapObject;
const nearest = (source, targets) => {
    if (targets.length === 0)
        return null;
    if (targets.length === 1)
        return targets[0];
    return targets
        .map(point => [point, Math.pow(point.y - source.y, 2) + Math.pow(point.x - source.x, 2)])
        .sort(([, d1], [, d2]) => d1 - d2)[0][0];
};
exports.nearest = nearest;
