"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAxisOrigin = exports.isTimeScale = exports.isLinearScale = exports.isContinuesScale = void 0;
const scale_1 = require("../types/scale");
const isContinuesScale = (scale) => [scale_1.ScaleType.Linear, scale_1.ScaleType.Time].includes(scale === null || scale === void 0 ? void 0 : scale.type);
exports.isContinuesScale = isContinuesScale;
const isLinearScale = (scale) => (scale === null || scale === void 0 ? void 0 : scale.type) === scale_1.ScaleType.Linear;
exports.isLinearScale = isLinearScale;
const isTimeScale = (scale) => (scale === null || scale === void 0 ? void 0 : scale.type) === scale_1.ScaleType.Time;
exports.isTimeScale = isTimeScale;
const getAxisOrigin = (scale) => {
    var _a;
    const domain = (_a = scale.getOptions().domain) !== null && _a !== void 0 ? _a : [];
    return (0, exports.isLinearScale)(scale) && domain[0] < 0 && domain[1] > 0 ? 0 : domain[0];
};
exports.getAxisOrigin = getAxisOrigin;
