import { Chart, ChartOptions } from '../types';
import { Element } from '../types/geometry';
export declare class AnimationManager {
    private options?;
    private chart;
    constructor(chart: Chart);
    update(options?: ChartOptions['animation']): void;
    fillUpOriginShapes(ele: Element): ({
        d: string;
        type: "rect";
        origin: import("../types").Point;
        width: number;
        height: number;
        radius?: number | undefined;
        transform?: {
            a: number;
            b: number;
            c: number;
            d: number;
            e: number;
            f: number;
        } | undefined;
        points?: import("../types").Point[] | undefined;
        strokeWidth?: number | undefined;
        strokeColor?: string | undefined;
        strokeStyle?: "solid" | "dashed" | undefined;
        dashedStyle?: number[] | undefined;
        fill?: string | undefined;
        fillOpacity?: number | undefined;
    } | {
        d: string;
        type: "circle";
        center: import("../types").Point;
        radius: number;
        transform?: {
            a: number;
            b: number;
            c: number;
            d: number;
            e: number;
            f: number;
        } | undefined;
        points?: import("../types").Point[] | undefined;
        strokeWidth?: number | undefined;
        strokeColor?: string | undefined;
        strokeStyle?: "solid" | "dashed" | undefined;
        dashedStyle?: number[] | undefined;
        fill?: string | undefined;
        fillOpacity?: number | undefined;
    } | {
        d: string;
        type: "line";
        from: import("../types").Point;
        to: import("../types").Point;
        transform?: {
            a: number;
            b: number;
            c: number;
            d: number;
            e: number;
            f: number;
        } | undefined;
        points?: import("../types").Point[] | undefined;
        strokeWidth?: number | undefined;
        strokeColor?: string | undefined;
        strokeStyle?: "solid" | "dashed" | undefined;
        dashedStyle?: number[] | undefined;
        fill?: string | undefined;
        fillOpacity?: number | undefined;
    } | {
        d: string;
        type: "polyline";
        points: import("../types").Point[];
        transform?: {
            a: number;
            b: number;
            c: number;
            d: number;
            e: number;
            f: number;
        } | undefined;
        strokeWidth?: number | undefined;
        strokeColor?: string | undefined;
        strokeStyle?: "solid" | "dashed" | undefined;
        dashedStyle?: number[] | undefined;
        fill?: string | undefined;
        fillOpacity?: number | undefined;
    } | {
        d: string;
        type: "polygon";
        points: import("../types").Point[];
        transform?: {
            a: number;
            b: number;
            c: number;
            d: number;
            e: number;
            f: number;
        } | undefined;
        strokeWidth?: number | undefined;
        strokeColor?: string | undefined;
        strokeStyle?: "solid" | "dashed" | undefined;
        dashedStyle?: number[] | undefined;
        fill?: string | undefined;
        fillOpacity?: number | undefined;
    } | {
        d: string;
        type: "path";
        transform?: {
            a: number;
            b: number;
            c: number;
            d: number;
            e: number;
            f: number;
        } | undefined;
        points?: import("../types").Point[] | undefined;
        strokeWidth?: number | undefined;
        strokeColor?: string | undefined;
        strokeStyle?: "solid" | "dashed" | undefined;
        dashedStyle?: number[] | undefined;
        fill?: string | undefined;
        fillOpacity?: number | undefined;
    } | {
        d: string;
        type: "text";
        position: import("../types").Point;
        text: string[];
        transform?: {
            a: number;
            b: number;
            c: number;
            d: number;
            e: number;
            f: number;
        } | undefined;
        points?: import("../types").Point[] | undefined;
        strokeWidth?: number | undefined;
        strokeColor?: string | undefined;
        strokeStyle?: "solid" | "dashed" | undefined;
        dashedStyle?: number[] | undefined;
        fill?: string | undefined;
        fillOpacity?: number | undefined;
        align?: "left" | "center" | "right" | undefined;
        verticalAlign?: "top" | "middle" | "bottom" | undefined;
        color?: string | undefined;
        fontSize?: number | undefined;
        fontWeight?: string | undefined;
        lineHeight?: number | undefined;
    })[];
    findLastElement(cid: string, eid: string, prev: Element[]): Element;
    composeAnimation(cur: Element[], prev: Element[]): Element[];
}
