import { GraphicOptions } from '../types/chart';
import { Element } from '../types/geometry';
import type { Chart } from '.';
export declare enum ComponentType {
    Geometry = 1,
    Axis = 2,
    Legend = 3,
    Tooltip = 4,
    GuideLine = 5,
    GuidePoint = 6,
    GuideLabel = 7
}
export declare abstract class ChartComponent {
    protected chart: Chart;
    id: string;
    constructor(chart: Chart, type: ComponentType);
    abstract animatable: boolean;
    abstract update(options: unknown): void;
    abstract graphic(chart: Chart, graphicOptions: GraphicOptions): Element[];
}
export declare class ComponentIdGenerator {
    static counter: {
        1: number;
        2: number;
        3: number;
        4: number;
        5: number;
        6: number;
        7: number;
    };
    static gen(type: ComponentType): string;
}
export declare const cid: typeof ComponentIdGenerator.gen;
