export var ComponentType;
(function (ComponentType) {
    ComponentType[ComponentType["Geometry"] = 1] = "Geometry";
    ComponentType[ComponentType["Axis"] = 2] = "Axis";
    ComponentType[ComponentType["Legend"] = 3] = "Legend";
    ComponentType[ComponentType["Tooltip"] = 4] = "Tooltip";
    ComponentType[ComponentType["GuideLine"] = 5] = "GuideLine";
    ComponentType[ComponentType["GuidePoint"] = 6] = "GuidePoint";
    ComponentType[ComponentType["GuideLabel"] = 7] = "GuideLabel";
})(ComponentType || (ComponentType = {}));
export class ChartComponent {
    // abstract elements: Element[]
    constructor(chart, type) {
        this.chart = chart;
        this.id = cid(type);
    }
}
export class ComponentIdGenerator {
    static gen(type) {
        return `${type}${ComponentIdGenerator.counter[type]++}`;
    }
}
ComponentIdGenerator.counter = {
    [ComponentType.Geometry]: 0,
    [ComponentType.Axis]: 0,
    [ComponentType.Legend]: 0,
    [ComponentType.Tooltip]: 0,
    [ComponentType.GuideLine]: 0,
    [ComponentType.GuidePoint]: 0,
    [ComponentType.GuideLabel]: 0,
};
export const cid = ComponentIdGenerator.gen;
