import Scale from '../scale';
import { uniqueFilter } from '../utils/data';
import { isNil } from '../utils/judgement';
export class DataSource {
    constructor(data, scaleOptions) {
        this.data = data;
        this.fields = data
            .map(record => Object.keys(record))
            .reduce((res, val) => res.concat(val), []) // flatten
            .filter(uniqueFilter)
            .reduce((res, field) => {
            const fieldDatas = data.map(record => record[field]).filter(value => !isNil(value));
            const fieldScale = new Scale(fieldDatas, scaleOptions === null || scaleOptions === void 0 ? void 0 : scaleOptions[field]);
            return Object.assign(Object.assign({}, res), { [field]: {
                    data: fieldDatas,
                    scale: fieldScale,
                } });
        }, {});
    }
    getData() {
        return this.data;
    }
    getField(field) {
        var _a;
        const { data, scale } = (_a = this.fields[field]) !== null && _a !== void 0 ? _a : {};
        return {
            getData() {
                return data;
            },
            getScale() {
                return scale;
            },
        };
    }
}
