import { Point } from '../types/geometry';
import { CoordinateOptions } from '../types/coord';
import { Linear } from '@antv/scale';
export default abstract class Coordinate {
    options: Required<CoordinateOptions>;
    xRange: [number, number];
    yRange: [number, number];
    center: Point;
    rangeScale: Linear;
    static defaultOptions: CoordinateOptions;
    constructor(options: CoordinateOptions);
    update(options: CoordinateOptions): void;
    get isPolar(): boolean;
    get isTransposed(): boolean;
    abstract convertPoint(point: Point, flag?: boolean): Point;
    abstract invertPoint(point: Point, flag?: boolean): Point;
    abstract map(point: Point): Point;
    abstract invert(point: Point): Point;
    protected transpose(point: Point): {
        x: any;
        y: any;
    };
}
