import { AestheticConfigObject, GeometryOptions, Point } from '../types/geometry';
import { DataRecord } from '../types/chart';
import type { Chart } from '../chart';
import { ChartComponent } from '../chart/component';
import { Aesthetic } from './aesthetic';
import { DataSource } from '../chart/data';
export declare abstract class Geometry extends ChartComponent {
    constructor(chart: Chart);
    update(options: GeometryOptions): void;
    abstract type: string;
    abstract options: GeometryOptions;
    xDim: string;
    yDim: string;
    groupedData: DataRecord[][];
    dataSource: DataSource;
    abstract defaultAestheticOptions: Record<'size' | 'color', AestheticConfigObject<unknown>>;
    groupData(data: DataRecord[], groupDim?: string): DataRecord[][];
    checkAndUpdateGroupedData(chart: Chart): void;
    recomputeDomainforStack(): void;
    getAxisOrigin(chart: Chart): {
        x: any;
        y: any;
    };
    generatePositionData(chart: Chart, aesthetic: Aesthetic, opt?: {
        xCentered?: boolean;
        width?: number;
    }): {
        points: Point[];
        record: DataRecord;
    }[][];
}
