import { GraphicOptions } from '../types/chart';
import { Element, PointOptions } from '../types/geometry';
import { Chart } from '../chart';
import { Geometry } from './abstract';
import { Coordinate } from '../coord';
import { Point as GeometryPoint } from '../types/geometry';
export declare class Point extends Geometry {
    type: string;
    animatable: boolean;
    options: PointOptions;
    defaultOptions: Partial<PointOptions>;
    defaultAestheticOptions: {
        position: {};
        shape: {};
        size: {
            value: number[];
        };
        color: {
            value: string[];
        };
        label: {};
    };
    constructor(chart: Chart, options: PointOptions);
    update(options: PointOptions): void;
    graphic(chart: Chart, graphicOptions: GraphicOptions): Element[];
    coordinate(point: GeometryPoint, coord: Coordinate): GeometryPoint;
}
