import { FieldData, GraphicOptions } from '../types/chart';
import { Element, BasicShape } from '../types/geometry';
import { AxisOptions } from '../types/guide';
import type { Chart } from '../chart';
import { Guide } from './abstract';
import Scale from '../scale';
import { Coordinate } from '../coord';
export declare class Axis extends Guide {
    animatable: boolean;
    options: AxisOptions;
    defaultOptions: Partial<AxisOptions>;
    origin?: FieldData;
    axisType: 'x' | 'y';
    field: string;
    verticalAxisField?: string;
    constructor(chart: Chart, options: AxisOptions);
    update(options: AxisOptions): void;
    layout(chart: Chart): [number, number, number, number];
    graphic(chart: Chart, graphicOptions: GraphicOptions): Element[];
    getAxisLine: (graphicOptions: GraphicOptions, axisOrigin: number, coord: Coordinate) => BasicShape;
    getTicks: (ticks: number[], axisOrigin: number, scale: Scale, coord: Coordinate) => BasicShape[];
    getLabels: (graphicOptions: GraphicOptions, ticks: number[], axisOrigin: number, scale: Scale, coord: Coordinate) => BasicShape[];
    getGrids: (graphicOptions: GraphicOptions, ticks: number[], scale: Scale, coord: Coordinate) => BasicShape[];
}
