import merge from 'lodash-es/merge';
import { LINE_COLOR } from '../const/color';
import { ComponentType } from '../chart/component';
import { Guide } from './abstract';
import { Aesthetic } from './aesthetic';
export class GuideLine extends Guide {
    constructor(chart, options) {
        super(chart, ComponentType.GuideLine);
        this.animatable = false;
        this.defaultOptions = {
            style: {
                strokeWidth: 1,
                strokeColor: LINE_COLOR,
            },
        };
        this.update(options);
    }
    update(options) {
        this.options = merge(this.defaultOptions, options);
    }
    graphic(chart, graphicOptions) {
        const aesthetic = new Aesthetic(chart, graphicOptions);
        const from = aesthetic.position(this.options.start);
        const to = aesthetic.position(this.options.end);
        return [
            {
                cid: this.id,
                eid: this.id,
                shapes: [
                    Object.assign({ type: 'line', from,
                        to }, this.options.style),
                ],
            },
        ];
    }
}
