import merge from 'lodash-es/merge';
import { DEFAULT_COLORS } from '../const/color';
import { ComponentType } from '../chart/component';
import { Guide } from './abstract';
import { Aesthetic } from './aesthetic';
export class GuidePoint extends Guide {
    constructor(chart, options) {
        super(chart, ComponentType.GuidePoint);
        this.animatable = false;
        this.defaultOptions = {
            size: 2,
            style: {
                fill: DEFAULT_COLORS[0],
            },
        };
        this.update(options);
    }
    update(options) {
        this.options = merge(this.defaultOptions, options);
    }
    graphic(chart, graphicOptions) {
        const aesthetic = new Aesthetic(chart, graphicOptions);
        const center = aesthetic.position(this.options.position);
        return [
            {
                cid: this.id,
                eid: this.id,
                shapes: [
                    Object.assign({ type: 'circle', center, radius: this.options.size }, this.options.style),
                ],
            },
        ];
    }
}
