import { Base, BaseOptions } from '@antv/scale';
import { FieldData } from '../types/chart';
import { ScaleOptions, ScaleType } from '../types/scale';
export default class Scale {
    type: ScaleType;
    private data;
    protected defaultOptions: BaseOptions;
    protected options: BaseOptions;
    protected scale: Base<BaseOptions>;
    constructor(data: FieldData[], options?: Partial<ScaleOptions>);
    protected getDefaultOptions(): Partial<BaseOptions>;
    getOptions(): BaseOptions;
    clone(): Scale;
    map(value: FieldData): any;
    invert(value: FieldData): any;
    update(updatedOptions: Partial<BaseOptions>): this;
    derive(updatedOptions: Partial<BaseOptions>): Scale;
    normalization(): Scale;
    /**
     * generate a new scale for position purpose, will extend domain to
     * the range of ticks
     *
     * @param {[number, number]} range
     * @memberof Scale
     */
    position({ range }: {
        range: [number, number];
    }): Scale;
    getTicks(): any[];
    getDomain(): any[] | undefined;
}
